## ufw 0.16.2

=== debian/changelog ===
ufw (0.16.2) hardy; urgency=low

  * don't log noisy services by default (LP: #209709)
  * don't log INVALID packets by default (LP: #207156)
  * consult /etc/services for protocol (LP: #209845)
    - src/ufw added get_services_proto() and adjust process_args() to use it
    - ufw.8 updated
    - tests added and updated for verification
  * bump version

 -- Jamie Strandboge <jamie@ubuntu.com>  Mon, 31 Mar 2008 15:21:17 -0400

ufw (0.16.1) hardy; urgency=low

  * debian/rules: use 'g' with sed when stripping paths (LP: #207476)
  * debian/control: set maintainer back to me
  * debian/control: set Vcs to the hardy branch
  * debian/control: Standards-Version: 3.7.3

 -- Jamie Strandboge <jamie@ubuntu.com>  Thu, 27 Mar 2008 09:15:25 -0400

ufw (0.16) hardy; urgency=low

  * bump version
  * fix tests for when ipv6 is blacklisted (fix FTBFS on Ubuntu buildd)
  * adjust root tests for new output

 -- Jamie Strandboge <jamie@ubuntu.com>  Tue, 11 Mar 2008 16:11:59 -0400

ufw (0.15) hardy; urgency=low

  * fix man page typo
  * debian/control: added Homepage (LP: #199722)
  * fix python version check (upstream #199790)
  * properly handle when ipv6 is not loaded or blacklisted (LP: #199724)
  * man page fixes
  * clarify 'status' output (LP: #199873)
  * fix ipv6 stateless autoconfiguration (upstream #200921)

 -- Jamie Strandboge <jamie@ubuntu.com>  Sat, 08 Mar 2008 07:36:04 -0500

ufw (0.14) hardy; urgency=low

  * conf/initscript
    - move sysctl to after rules load (LP: #192123)
    - don't make sysctl and modprobe failures fatal (LP: #197285)
    - make output less verbose and fix formatting (LP: #198211)
  * debian/rules: update setup.py version with changelog version
  * debian/control
    - update maintainer to Ubuntu Core Developers
    - add Vcs-Bzr url

 -- Jamie Strandboge <jamie@ubuntu.com>  Fri, 15 Feb 2008 08:56:24 -0500

ufw (0.13) hardy; urgency=low

  * added ipv6 and (commented out) forwarding entries in sysctl.conf

 -- Jamie Strandboge <jamie@ubuntu.com>  Wed, 13 Feb 2008 22:31:47 -0500

ufw (0.12) hardy; urgency=low

  * new upstream version:
    - initscript implements 'stop' as default ACCEPT
    - initscript restart and force-reload now use 'stop' and 'start'
  * debian/postinst: stop on runlevels 0, 1 and 6
  * debian/postrm: default ACCEPT on purge
  * debian/README.Debian: provide useful notes

 -- Jamie Strandboge <jamie@ubuntu.com>  Thu, 07 Feb 2008 09:47:10 -0500

ufw (0.11) hardy; urgency=low

  * comply with Ubuntu policy of syncookies off (LP: 189565) 
  * debian/control: Build-Depends on debhelper (>= 5.0.38)

 -- Jamie Strandboge <jamie@ubuntu.com>  Wed, 06 Feb 2008 14:08:36 -0500

ufw (0.10) hardy; urgency=low

  * new upstream version:
    - ipv6 support (LP: 188934)
    - added more tests
    - updated docs
  * updated packaging for ipv6 files
  * fixed email typo (LP: 189418)
  * use ucf for /etc/ufw/*.rules files
  * move ENABLED to ufw.conf

 -- Jamie Strandboge <jamie@ubuntu.com>  Tue, 05 Feb 2008 22:24:51 -0500

ufw (0.9) hardy; urgency=low

  * new upstream version:
    - bugfix for logging
    - bugfix for default policy

 -- Jamie Strandboge <jamie@ubuntu.com>  Tue, 29 Jan 2008 06:37:01 -0500

ufw (0.8) hardy; urgency=low

  * new upstream version:
    - use PF-style syntax for extended rule syntax
    - migrate ufw.rules to separate chains and files
  * added debconf note about ufw.rules

 -- Jamie Strandboge <jamie@ubuntu.com>  Mon, 28 Jan 2008 13:26:10 -0500

ufw (0.7) hardy; urgency=low

  * new version
    - fix two lintian warnings
    - manpage updates
    - fix for buggy get_status

 -- Jamie Strandboge <jamie@ubuntu.com>  Thu, 24 Jan 2008 11:27:30 +0000

ufw (0.6) hardy; urgency=low

  * debian/control: Build-Depends-Indep on netbase so tests can run in
    buildds

 -- Jamie Strandboge <jamie@ubuntu.com>  Wed, 23 Jan 2008 16:24:58 +0000

ufw (0.5) hardy; urgency=low

  * update tests for better failure reporting and maintainability 

 -- Jamie Strandboge <jamie@ubuntu.com>  Wed, 23 Jan 2008 13:14:20 +0000

ufw (0.4) hardy; urgency=low

  * new upstream version
    - supports specifying service from /etc/services
    - requires python 2.5
    - put rules in ufw-* chains
    - status is more user-friendly (but not complete)
    - bug fixes
    - ufw.rules fine-tuning

 -- Jamie Strandboge <jamie@ubuntu.com>  Tue, 22 Jan 2008 08:01:06 +0000

ufw (0.3) hardy; urgency=low

  * new upstream version:
    - fix licensing
    - PEP8 compliant
    - uses distutils to install
    - now supports /etc/services names

 -- Jamie Strandboge <jamie@ubuntu.com>  Sun, 20 Jan 2008 17:43:03 -0500

ufw (0.2) hardy; urgency=low

  * ufw: actually use DROP instead of DENY
  * typo in README.Debian

 -- Jamie Strandboge <jamie@ubuntu.com>  Wed, 16 Jan 2008 14:32:06 -0500

ufw (0.1) hardy; urgency=low

  * Initial release

 -- Jamie Strandboge <jamie@ubuntu.com>  Mon, 07 Jan 2008 20:44:16 -0500

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

PYTHON  := /usr/bin/python
PYVERS  := $(shell pyversions -vr)
UBUVERS := $(shell dpkg-parsechangelog | grep ^Version: | cut -d ' ' -f 2)

build: build-stamp

build-stamp:
	dh_testdir
	touch $@

clean:
	dh_testdir
	dh_testroot
	rm -f build-stamp
	rm -rf $(CURDIR)/build
	dh_clean 

install: build
	dh_testdir
	dh_testroot
	dh_clean -k 
	dh_installdirs usr/share/
	dh_installdirs usr/share/ufw
	dh_installdirs etc/

	# make sure the version is in sync with our changelog
	sed -i "s/^ufw_version = .*/ufw_version = '$(UBUVERS)'/" ./setup.py

	./run_tests.sh
	python ./setup.py install \
		--root=$(CURDIR)/debian/ufw
	rm -rf $(CURDIR)/debian/ufw/usr/lib

	# don't make *.rules conffiles
	mv $(CURDIR)/debian/ufw/etc/ufw/*.rules $(CURDIR)/debian/ufw/usr/share/ufw
	mv $(CURDIR)/debian/ufw/etc/ufw/ufw.conf $(CURDIR)/debian/ufw/usr/share/ufw
	mv $(CURDIR)/debian/ufw/var/lib/ufw/*.rules $(CURDIR)/debian/ufw/usr/share/ufw
	cp $(CURDIR)/debian/*md5sum $(CURDIR)/debian/ufw/usr/share/ufw

	# strip out beginning of path since setup.py doens't support dest-dir
	# yet
	find $(CURDIR)/debian/ufw -type f -exec sed "s#$(CURDIR)/debian/ufw##g" -i {} \;

binary-arch: build

binary-indep: build install
	dh_testdir
	dh_testroot
	dh_installchangelogs 
	dh_installdocs
	dh_installdocs README
	dh_installman
	dh_installdebconf

	: # Replace all '#!' calls to python with $(PYTHON)
	: # and make them executable
	for i in `find debian -mindepth 3 -type f`; do \
		sed '1s,#!.*python[^ ]*\(.*\),#! $(PYTHON)\1,' \
			$$i > $$i.temp; \
		if cmp --quiet $$i $$i.temp; then \
			rm -f $$i.temp; \
		else \
			mv -f $$i.temp $$i; \
			chmod 755 $$i; \
			echo "fixed interpreter: $$i"; \
		fi; \
	done

	dh_pycentral
	dh_compress
	dh_fixperms
	dh_installdeb
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary: binary-indep binary-arch
.PHONY: build clean binary instal

## ufw 0.23.3

=== Makefile ===
SRCS     = src/ufw $(wildcard src/*.py)
POTFILES = messages/ufw.pot

all:
	# Use setup.py to install. See README for details
	exit 1

install: all

test:
	./run_tests.sh -s

clean:
	rm -rf /tmp/ufw

evaluate: clean
	mkdir -p /tmp/ufw/usr /tmp/ufw/etc
	python ./setup.py install --home=/tmp/ufw
	sed -i 's/self.do_checks = True/self.do_checks = False/' /tmp/ufw/lib/python/ufw/backend.py
	cp ./examples/* /tmp/ufw/etc/ufw/applications.d

devel: evaluate
	cp -f ./tests/defaults/profiles/* /tmp/ufw/etc/ufw/applications.d
	cp -f ./tests/defaults/profiles.bad/* /tmp/ufw/etc/ufw/applications.d

debug: devel
	sed -i 's/debugging = False/debugging = True/' /tmp/ufw/lib/python/ufw/util.py

translations: $(POTFILES)

$(POTFILES): $(SRCS)
	pygettext -v -d ufw -p messages -S GNU $(SRCS)

## ufw 0.16.2.3

=== debian/changelog ===
ufw (0.16.2.3) hardy-proposed; urgency=low

  * fix confusing error output when ipv6 or ip6_tables is not available.
    (LP: #194844)
  * fix initscript not setting default ipv6 policy when IPV6=no (LP: #251355)

 -- Jamie Strandboge <jamie@ubuntu.com>  Fri, 11 Jul 2008 18:37:27 -0400

ufw (0.16.2.2) hardy-proposed; urgency=low

  * src/ufw: don't modify the chains when --dry-run is specified. Fixes
    LP: #247352

 -- Jamie Strandboge <jamie@ubuntu.com>  Wed, 09 Jul 2008 15:24:18 -0400

ufw (0.16.2.1) hardy-proposed; urgency=low

  * prevent traceback with dotted decimal netmasks (LP: #224842)
  * update tests to test for more valid and invalid netmasks

 -- Jamie Strandboge <jamie@ubuntu.com>  Wed, 23 Apr 2008 09:52:02 -0400

=== debian/control ===
Source: ufw
Section: admin
XS-Python-Version: >= 2.5
Priority: optional
Maintainer: Jamie Strandboge <jamie@ubuntu.com>
Build-Depends-Indep: python-central (>= 0.5.6), sed (>= 3.95), netbase, po-debconf
Build-Depends: debhelper (>= 5.0.38)
Standards-Version: 3.7.3
Homepage: https://launchpad.net/ufw
Vcs-Bzr: https://bazaar.launchpad.net/~jamie-strandboge/ufw/ufw-0.16-hardy

Package: ufw
Architecture: all
Depends: debconf, ${python:Depends}, iptables (>= 1.3.3), ucf
XB-Python-Version: ${python:Versions}
Description: program for managing a netfilter firewall 
 Ufw is a tool to manage a local host-based firewall. It provides a command
 line interface and aims to be uncomplicated and easy to use.

## ufw 0.16.2.4

=== debian/changelog ===
ufw (0.16.2.4) hardy-proposed; urgency=low

  * debian/postrm: don't fail if iptables or ip6tables fails (LP: #278670)
  * debian/postinst: don't stop in runlevels 0 and 6 (LP: #298736)
  * don't do symlink check anymore (LP: #317700)
  * conf/initscript: don't flush rules on stop when not enabled (LP: #311066)
  * debian/control: update Vcs information

 -- Jamie Strandboge <jamie@ubuntu.com>  Sat, 17 Jan 2009 09:04:06 -0600

## ufw 0.23.2

=== debian/changelog ===
ufw (0.23.2) intrepid; urgency=low

  * fix typo in error message (LP: #280348)

 -- Jamie Strandboge <jamie@ubuntu.com>  Tue, 07 Oct 2008 09:22:34 -0500

ufw (0.23.1) intrepid; urgency=low

  * debian/postrm: don't fail if iptables or ip6tables fails (LP: #278670)

 -- Jamie Strandboge <jamie@ubuntu.com>  Mon, 29 Sep 2008 13:43:11 -0500

ufw (0.23) intrepid; urgency=low

  * show protocol in status when no ports are specified (LP: #263308)
  * update after*.rules when setting default policy (LP: #273278)
  * give useful message when trying to delete a non-existent rule (LP: #251136)
  * don't print useless newlines
  * add 'translations' support to Makefile (but don't use it in build yet)
  * updated README for advanced usage
  * updated TODO
  * References
    LP: #275984

 -- Jamie Strandboge <jamie@ubuntu.com>  Mon, 29 Sep 2008 11:52:53 -0500

ufw (0.22) intrepid; urgency=low

  * fix confusing output of 'app update' command (LP: #261932)
  * only reload during 'app update' if the profile name is used in
    the current ruleset (LP: #261323)
  * don't reload user rules if not enabled and don't toggle ENABLED=yes if
    failure in starting the firewall (LP: #262451)
  * don't traceback if /proc not mounted (LP: #268084)

 -- Jamie Strandboge <jamie@ubuntu.com>  Wed, 27 Aug 2008 11:51:14 -0500

ufw (0.21) intrepid; urgency=low

  * add confirmation on enable when running under ssh (LP: #253840)
  * don't reload the firewall on 'app update' when running under ssh
  * update ufw.pot
  * fix some pygettext errors
  * warn if profile name is found in /etc/services
  * don't delete application rules when the action doesn't match
    (LP: #260881)
  * add reload command
  * added debian/triggers and update debian/postinst for use with dpkg
    triggers (thanks Colin Watson for the suggestion)
  * add 'app update all' command
  * update man page for reload and 'app update all'

 -- Jamie Strandboge <jamie@ubuntu.com>  Mon, 18 Aug 2008 20:22:32 -0400

ufw (0.20) intrepid; urgency=low

  * add 'verbose' option to status command
  * implement application (package) integration
  * update run_tests.sh to honor subclass
  * debian/control: Depends on iptables >= 1.4.0 for ipv6 comment support

 -- Jamie Strandboge <jamie@ubuntu.com>  Thu, 07 Aug 2008 12:04:05 -0400

ufw (0.19) intrepid; urgency=low

  * don't modify the chains when --dry-run is specified (LP: #247352)
  * add dotted netmask support
  * don't have util.py import common.py
  * normalize rules so what is added to chains and what is displayed to the
    user is consistent (LP: #237446)
  * documentation updates (LP: #247177)
  * implement port ranges (LP: #231103)
  * fix initscript to properly set default DROP when ipv6 is available and
    set to 'no' in /etc/default/ufw (LP: #251355)
  * don't give confusing output when ipv6 and/or ip6_tables is not
    available (LP: #194844)
  * update ucf historical checksums to include those in 0.16.2
  * update manpage for 'status' clarifications (LP: #251153)
  * update before*.rules to count outgoing packets on lo (LP: #255092)
  * update status output so it is more consistent with rule syntax

 -- Jamie Strandboge <jamie@ubuntu.com>  Mon, 07 Jul 2008 16:22:45 -0400

ufw (0.18) intrepid; urgency=low

  * bump version
  * src/ufw: make reusable
  * src/ufw: show default policy and logging in 'status' (LP: #240271)
  * refactor code and split out into modules:
    - updated src/*
    - updated setup.py
    - updated run_tests.sh
    - updated README
    - updated README.translations and messages/ufw.pot
    - updated README.Design
  * properly implement --root and --home (LP: #231771):
    - setup.py: --root works as expected now (eg as DESTDIR in Debian)
    - updated run_test.sh for new setup.py
    - updated README.Debian for now setup.py
  * add new 'limit' command for connection rate limiting:
    - updated src/*
    - updated README and ufw.8
    - updated messages/ufw.pot
    - updated tests for limit

 -- Jamie Strandboge <jamie@ubuntu.com>  Thu, 12 Jun 2008 10:28:36 -0400

ufw (0.17) intrepid; urgency=low

  * implement status in initscript
  * warn on group/world writable and wrong owner files in _do_checks()
  * debian/rules: use 'g' with sed when stripping paths (LP: #207476)
  * debian/control: Standards-Version: 3.7.3
  * don't log INVALID packets by default (LP: #207156)
  * don't log noisy services by default (LP: #209709)
  * consult /etc/services for protocol (LP: #209845)
  * manpage updates
  * add internationalization support
  * prevent traceback with dotted decimal netmasks (LP: #224842)
  * update tests to test for more valid and invalid netmasks
  * adjust conf/sysctl.conf to have clear message regarding /etc/sysctl.conf
  * adjust conf/sysctl.conf to have explanations for the tunables (taken from
    procps)

 -- Jamie Strandboge <jamie@ubuntu.com>  Wed, 12 Mar 2008 16:11:22 -0400

=== debian/control ===
Source: ufw
Section: admin
XS-Python-Version: >= 2.5
Priority: optional
Maintainer: Jamie Strandboge <jamie@ubuntu.com>
Build-Depends-Indep: python-central (>= 0.5.6), sed (>= 3.95), netbase, po-debconf
Build-Depends: debhelper (>= 5.0.38)
Standards-Version: 3.7.3
Homepage: https://launchpad.net/ufw
Vcs-Bzr: https://bazaar.launchpad.net/~jamie-strandboge/ufw/trunk

Package: ufw
Architecture: all
Depends: debconf, ${python:Depends}, iptables (>= 1.4.0), ucf
XB-Python-Version: ${python:Versions}
Description: program for managing a netfilter firewall
 Ufw is a tool to manage a local host-based firewall. It provides a command
 line interface and aims to be uncomplicated and easy to use.

=== debian/rules ===
--- 
+++ 
@@ -19,6 +19,7 @@
 	dh_testroot
 	rm -f build-stamp
 	rm -rf $(CURDIR)/build
+	-find . -name '*.py[co]' | xargs rm -f
 	dh_clean 
 
 install: build
@@ -35,17 +36,12 @@
 	./run_tests.sh
 	python ./setup.py install \
 		--root=$(CURDIR)/debian/ufw
-	rm -rf $(CURDIR)/debian/ufw/usr/lib
 
 	# don't make *.rules conffiles
 	mv $(CURDIR)/debian/ufw/etc/ufw/*.rules $(CURDIR)/debian/ufw/usr/share/ufw
 	mv $(CURDIR)/debian/ufw/etc/ufw/ufw.conf $(CURDIR)/debian/ufw/usr/share/ufw
 	mv $(CURDIR)/debian/ufw/var/lib/ufw/*.rules $(CURDIR)/debian/ufw/usr/share/ufw
 	cp $(CURDIR)/debian/*md5sum $(CURDIR)/debian/ufw/usr/share/ufw
-
-	# strip out beginning of path since setup.py doens't support dest-dir
-	# yet
-	find $(CURDIR)/debian/ufw -type f -exec sed "s#$(CURDIR)/debian/ufw##g" -i {} \;
 
 binary-arch: build

## ufw 0.23.3

=== debian/changelog ===
ufw (0.23.3) intrepid-proposed; urgency=low

  * debian/postinst: don't stop in runlevels 0 and 6 (LP: #298736)
  * don't do symlink check anymore (LP: #317700)
  * conf/initscript: don't flush rules on stop when not enabled (LP: #311066)
  * formatting of dpkg output incorrect on upgrades (LP: #300726)
  * debian/control: update Vcs information

 -- Jamie Strandboge <jamie@ubuntu.com>  Mon, 19 Jan 2009 10:32:03 -0600

=== debian/control ===
--- 
+++ 
@@ -7,7 +7,7 @@
 Build-Depends: debhelper (>= 5.0.38)
 Standards-Version: 3.7.3
 Homepage: https://launchpad.net/ufw
-Vcs-Bzr: https://bazaar.launchpad.net/~jamie-strandboge/ufw/trunk
+Vcs-Bzr: https://bazaar.launchpad.net/~jamie-strandboge/ufw/ufw-0.23-intrepid
 
 Package: ufw
 Architecture: all

## ufw 0.27

=== Makefile ===
SRCS     = src/ufw $(wildcard src/*.py)
POTFILES = messages/ufw.pot
TMPDIR   = ./tmp
EXCLUDES = --exclude='.bzr*' --exclude='*~' --exclude='*.swp' --exclude='*.pyc' --exclude='debian' --exclude='ubuntu'
VERSION  = $(shell egrep '^ufw_version' ./setup.py | cut -d "'" -f 2)
SRCVER   = ufw-$(VERSION)
TARBALLS = ../tarballs
TARSRC   = $(TARBALLS)/$(SRCVER)
TARDST   = $(TARBALLS)/$(SRCVER).tar.gz

translations: $(POTFILES)
$(POTFILES): $(SRCS)
	pygettext -v -d ufw -p messages -S GNU $(SRCS)

test:
	./run_tests.sh -s

all:
	# Use setup.py to install. See README for details
	exit 1

install: all

# These are only used in development
clean:
	rm -rf ./build
	rm -rf ./staging
	rm -rf ./tests/testarea
	rm -rf $(TMPDIR)

evaluate: clean
	mkdir -p $(TMPDIR)/ufw/usr $(TMPDIR)/ufw/etc
	python ./setup.py install --home=$(TMPDIR)/ufw
	sed -i 's/self.do_checks = True/self.do_checks = False/' $(TMPDIR)/ufw/lib/python/ufw/backend.py
	cp ./examples/* $(TMPDIR)/ufw/etc/ufw/applications.d
	# Test with:
	# PYTHONPATH=$$PYTHONPATH:$(TMPDIR)/ufw/lib/python $(TMPDIR)/ufw/usr/sbin/ufw ...
	# sudo sh -c "PYTHONPATH=$$PYTHONPATH:$(TMPDIR)/ufw/lib/python $(TMPDIR)/ufw/usr/sbin/ufw ..."

devel: evaluate
	cp -f ./tests/defaults/profiles/* $(TMPDIR)/ufw/etc/ufw/applications.d
	cp -f ./tests/defaults/profiles.bad/* $(TMPDIR)/ufw/etc/ufw/applications.d

debug: devel
	sed -i 's/debugging = False/debugging = True/' $(TMPDIR)/ufw/lib/python/ufw/util.py

tarball: clean translations
	bzr export --format dir $(TARSRC)
	tar -zcv -C $(TARBALLS) $(EXCLUDES) -f $(TARDST) $(SRCVER)
	rm -rf $(TARSRC)

## ufw 0.29

=== Makefile ===
--- 
+++ 
@@ -1,5 +1,5 @@
 SRCS     = src/ufw $(wildcard src/*.py)
-POTFILES = messages/ufw.pot
+POTFILES = locales/po/ufw.pot
 TMPDIR   = ./tmp
 EXCLUDES = --exclude='.bzr*' --exclude='*~' --exclude='*.swp' --exclude='*.pyc' --exclude='debian' --exclude='ubuntu'
 VERSION  = $(shell egrep '^ufw_version' ./setup.py | cut -d "'" -f 2)
@@ -8,18 +8,23 @@
 TARSRC   = $(TARBALLS)/$(SRCVER)
 TARDST   = $(TARBALLS)/$(SRCVER).tar.gz
 
-translations: $(POTFILES)
-$(POTFILES): $(SRCS)
-	pygettext -v -d ufw -p messages -S GNU $(SRCS)
-
-test:
-	./run_tests.sh -s
-
 all:
 	# Use setup.py to install. See README for details
 	exit 1
 
 install: all
+
+translations: $(POTFILES)
+$(POTFILES): $(SRCS)
+	xgettext -d ufw -L Python -o $@ $(SRCS)
+	make -c po/Makefile all
+
+mo:
+	make -C locales all
+
+test:
+	./run_tests.sh -s
+
 
 # These are only used in development
 clean:
@@ -31,6 +36,7 @@
 evaluate: clean
 	mkdir -p $(TMPDIR)/ufw/usr $(TMPDIR)/ufw/etc
 	python ./setup.py install --home=$(TMPDIR)/ufw
+	PYTHONPATH=$(PYTHONPATH):$(TMPDIR)/ufw/lib/python $(TMPDIR)/ufw/usr/sbin/ufw version
 	sed -i 's/self.do_checks = True/self.do_checks = False/' $(TMPDIR)/ufw/lib/python/ufw/backend.py
 	cp ./examples/* $(TMPDIR)/ufw/etc/ufw/applications.d
 	# Test with:

## ufw 0.30pre1

=== Makefile ===
--- 
+++ 
@@ -17,7 +17,6 @@
 translations: $(POTFILES)
 $(POTFILES): $(SRCS)
 	xgettext -d ufw -L Python -o $@ $(SRCS)
-	make -c po/Makefile all
 
 mo:
 	make -C locales all
@@ -32,6 +31,7 @@
 	rm -rf ./staging
 	rm -rf ./tests/testarea
 	rm -rf $(TMPDIR)
+	rm -f ./locales/mo/*.mo
 
 evaluate: clean
 	mkdir -p $(TMPDIR)/ufw/usr $(TMPDIR)/ufw/etc

## ufw 0.31.1

=== Makefile ===
--- 
+++ 
@@ -7,6 +7,8 @@
 TARBALLS = ../tarballs
 TARSRC   = $(TARBALLS)/$(SRCVER)
 TARDST   = $(TARBALLS)/$(SRCVER).tar.gz
+PYFLAKES = $(TMPDIR)/pyflakes.out
+PYFLAKES_EXE = pyflakes
 
 all:
 	# Use setup.py to install. See README for details
@@ -24,6 +26,24 @@
 test:
 	./run_tests.sh -s
 
+syntax-check: clean
+	$(shell mkdir $(TMPDIR) && $(PYFLAKES_EXE) src 2>&1 | grep -v "undefined name '_'" > $(PYFLAKES))
+	cat "$(PYFLAKES)"
+	test ! -s "$(PYFLAKES)"
+
+man-check: clean
+	$(shell mkdir $(TMPDIR) 2>/dev/null)
+	for manfile in `ls doc/*.8`; do \
+		page=$$(basename $$manfile); \
+		manout=$(TMPDIR)/$$page.out; \
+		echo "Checking $$page for errors... "; \
+		PAGER=cat LANG='en_US.UTF-8' MANWIDTH=80 man --warnings -E UTF-8 -l doc/$$page >/dev/null 2> "$$manout"; \
+		cat "$$manout"; \
+		test ! -s "$$manout" || exit 1; \
+		echo "PASS"; \
+	done; \
+
+check: syntax-check man-check test
 
 # These are only used in development
 clean:
@@ -48,9 +68,9 @@
 	cp -f ./tests/defaults/profiles.bad/* $(TMPDIR)/ufw/etc/ufw/applications.d
 
 debug: devel
-	sed -i 's/debugging = False/debugging = True/' $(TMPDIR)/ufw/lib/python/ufw/util.py
+	sed -i 's/DEBUGGING = False/DEBUGGING = True/' $(TMPDIR)/ufw/lib/python/ufw/util.py
 
-tarball: clean translations
+tarball: syntax-check clean translations
 	bzr export --format dir $(TARSRC)
 	tar -zcv -C $(TARBALLS) $(EXCLUDES) -f $(TARDST) $(SRCVER)
 	rm -rf $(TARSRC)

=== debian/changelog ===
ufw (0.31.1-2) unstable; urgency=low

  * Simplify unload of firewall and play nicely with other firewall tools by
    using ufw-init instead of iptables directly. 'ufw-init stop' by design
    leaves a few empty chains around, but they won't get in the way of
    anything and are gone after the next reboot. Using upstream's ufw-init has
    the important benefit of always cleaning what it needs. (Closes: 672439).
    - debian/prerm: call '/lib/ufw/ufw-init stop' on removal
    - debian/postrm: don't flush the chains on purge

 -- Jamie Strandboge <jamie@ubuntu.com>  Fri, 20 Jul 2012 15:05:39 -0500

ufw (0.31.1-1) unstable; urgency=low

  * New upstream release (Closes: 663677, Closes: 625681)
  * debian/control: update to standards 3.9.3
  * convert to source format 3.0 (quilt)
  * 0001-optimize-boot.patch: only read in /etc/ufw/ufw.conf when disabled
  * debian/rules: adjust to only install the application profiles when not
    Ubuntu
  * debian/po/nl.po: add Dutch translation of debconf templates. Thanks to
    Jeroen Schot (Closes: 658495)
  * debian/po/da.po: add Danish translation of debconf templates. Thanks to
    Joe Dalton (Closes: 666557)

 -- Jamie Strandboge <jamie@ubuntu.com>  Wed, 04 Apr 2012 12:12:25 -0500

ufw (0.30.1-2) unstable; urgency=low

  * debian/control: make lintian clean:
    - update Standards-Version to 3.9.2
    - Build-Depends on python (>= 2.6.6-3~)
  * conf/ufw.defaults:
    - remove IRC connection tracking, which is only required for DCC.
      Cherrypick r741 from trunk
    - allow nf_conntrack_netbios_ns (Samba). Cherrypick r744 from trunk.
      LP: #360975 (Closes: 631737)
  * enable IPv6 by default and fix 'allow to any ipv6' when IPv6 is enabled.
    Cherrypick r742 from trunk.
  * update manpage references to ufw and ufw-framework to include the section.
    Cherrypick r743 from trunk.
  * ACCEPT UPnP (239.255.255.250 for IPv4 and ff02::f for IPv6) for service
    discovery just like we do for mDNS (ie, allow discovery, but not
    connections to the services). LP: #764933
  * debian/ufw.logrotate.debian, debian/ufw.logrotate.ubuntu, debian/rules:
    use 'rotate' option in Debian logrotate file and split out ufw.logrotate
    like we do the initscript since because Ubuntu's rsyslog doesn't have the
    'rotate' option yet. (Closes: 628605)
  * Cherrypick r746 from trunk to update check-requirements to prompt to
    continue with tests that may autoload modules. Add '-f' option to
    check-requirements and update test suite accordingly (LP: #782816)
  * Cherrypick r747 from trunk to not fail when running 'show listening' under
    fakeroot (LP: #812516)
  * debian/postinst:
    - remove some old upgrade transition code for unsupported upgrade paths
    - reload ufw if it is enabled and we are upgrading to this version since
      this is needed after enabling IPv6
  * debian/rules: add build-arch and build-indep targets

 -- Jamie Strandboge <jamie@ubuntu.com>  Mon, 18 Jul 2011 16:35:57 -0500

ufw (0.30.1-1.1) unstable; urgency=low

  * Non-maintainer upload.
  * Rebuild to add Python 2.7 support

 -- Piotr Ożarowski <piotr@debian.org>  Sun, 08 May 2011 16:45:46 +0200

ufw (0.30.1-1) unstable; urgency=low

  * New upstream release which fixes the following:
    - LP: #501140
    - LP: #740249
    - LP: #740256
    - LP: #720605
  * debian/ufw.logrotate: remove upstartism thanks to Michael Biebl
    (Closes: 607696)
  * debian/sysctl.conf: merge in upstream (commented out) changes surrounding
    ipv6 forwarding and privacy addresses
  * debian/before*.rules.md5sum: updated for recent changes

 -- Jamie Strandboge <jamie@ubuntu.com>  Mon, 21 Mar 2011 14:45:03 -0500

ufw (0.30.0-3) unstable; urgency=low

  * convert to dh_python2:
    - debian/control: remove python-central dependency
    - debian/rules: use dh_python2 instead of dh_pycentral
  * debian/rules: run 'make clean' in the clean target
  * debian/ufw.init.debian: look for /lib/ufw, not /usr/sbin/ufw to see if we
    should quit (ie, when ufw is removed and not purged). Also, only have
    /bin and /sbin in PATH
  * add lintian override
    - debian/rules: add dh_lintian
    - debian/dirs: add usr/share/lintian/overrides
    - ignore init.d-script-possible-missing-stop
  * debian/install, debian/rules: update to use debian/install primarily
  * renamed debian/changelog.pre-0.27.1 to debian/changelog.Debian.pre-0.27.1
  * no longer install upstream ChangeLog.pre-0.25
  * grab man page updates from upstream:
    - mention quoting of application profile names with spaces. Upstream
      r714. (LP: #715676)
    - fix man-page hyphenation in ufw.8. Upstream r716.
    - fix manpage reference to /etc/defaults/ufw. Upstream r713.
      (Closes: 601111)
  * fix typo in warning. Upstream r711. (LP: #637876)
  * run_tests.sh: adjust PATH if iptables can't be found. Upstream r717.

 -- Jamie Strandboge <jamie@ubuntu.com>  Wed, 23 Feb 2011 08:10:55 -0600

ufw (0.30.0-2) unstable; urgency=low

  * src/frontend.py: display unicode error messages properly. Thanks to
    Serguey Basalaev.
    - upstream commit r700
    - LP: #580032
  * src/backend_iptables.py: fix gettext warning
    - upstream commit r701
  * run debconf-updatepo, but adjust debian/po/de.po and debian/po/es.po to
    add correct "Language:" tag
  * profiles/ufw-mailserver: remove Postfix specific language
    - upstream commit r705, r707
  * debian/rules: do install the upstream application profiles now

 -- Jamie Strandboge <jamie@ubuntu.com>  Mon, 30 Aug 2010 13:50:15 -0500

ufw (0.30.0-1) unstable; urgency=low

  * New upstream release. Use 0.30.0 as the version even though upstream uses
    0.30 in order to sync to Ubuntu. Fixes:
    - LP: #568877
    - LP: #611982
    - LP: #606997
    - LP: #624199
    - LP: #625340
    - LP: #521359
    - LP: #436608
  * don't flush chains if ufw is not enabled (LP: #581744)
  * debian/postinst: don't source /usr/share/debconf/confmodule when $1 =


=== debian/control ===
Source: ufw
Section: admin
XS-Python-Version: >= 2.5
Priority: optional
Maintainer: Jamie Strandboge <jamie@ubuntu.com>
Build-Depends-Indep: sed (>= 3.95), netbase, iptables, lsb-release
Build-Depends: debhelper (>= 7.3.15ubuntu2), po-debconf, python (>= 2.6.6-3~)
Standards-Version: 3.9.3
Homepage: https://launchpad.net/ufw
Vcs-Bzr: https://bazaar.launchpad.net/~jdstrand/ufw/ufw-debian

Package: ufw
Architecture: all
Suggests: rsyslog
Depends: debconf, ${python:Depends}, ${misc:Depends}, iptables, ucf
XB-Python-Version: ${python:Versions}
Description: program for managing a Netfilter firewall
 The Uncomplicated FireWall is a front-end for iptables, to make managing a
 Netfilter firewall easier. It provides a command line interface with syntax
 similar to OpenBSD's Packet Filter. It is particularly well-suited as a
 host-based firewall.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

PYTHON  := /usr/bin/python
PYVERS  := $(shell pyversions -vr)
PKGVERS := $(shell dpkg-parsechangelog | grep ^Version: | cut -d ' ' -f 2)
DISTRIB := $(shell lsb_release -i -s)

ifneq (,$(filter $(DISTRIB),Ubuntu))
  DISTRIB_VERSION_MAJOR := $(shell lsb_release -s -r | cut -d '.' -f 1)
  DISTRIB_VERSION_MINOR := $(shell lsb_release -s -r | cut -d '.' -f 2)
endif

build-arch: build-stamp

build-indep: build-stamp

build: build-arch build-indep

build-stamp:
	dh_testdir
	touch $@

clean:
	dh_testdir
	dh_testroot
	rm -f build-stamp
	make clean
	rm -f $(CURDIR)/debian/ufw.init $(CURDIR)/debian/ufw.upstart $(CURDIR)/debian/ufw.logrotate
	-find . -name '*.py[co]' | xargs rm -f
	dh_clean
	debconf-updatepo

install: build
	dh_testdir
	dh_testroot
	dh_clean -k
	dh_installdirs

	# make sure the version is in sync with our changelog
	sed -i "s/^ufw_version = .*/ufw_version = '$(PKGVERS)'/" ./setup.py

ifeq (,$(findstring nocheck,$(DEB_BUILD_OPTIONS)))
	./run_tests.sh -i $(PYTHON)
endif

	$(PYTHON) ./setup.py install --root=$(CURDIR)/debian/ufw

	# these shouldn't be conffiles
	mv $(CURDIR)/debian/ufw/etc/ufw/*.rules $(CURDIR)/debian/ufw/usr/share/ufw
	mv $(CURDIR)/debian/ufw/etc/ufw/ufw.conf $(CURDIR)/debian/ufw/usr/share/ufw
	mv $(CURDIR)/debian/ufw/lib/ufw/*.rules $(CURDIR)/debian/ufw/usr/share/ufw

	# Rename and install the shell-completion file
	cp $(CURDIR)/shell-completion/bash $(CURDIR)/debian/ufw/etc/bash_completion.d/ufw

binary-arch: build

binary-indep: build install
	dh_testdir
	dh_testroot
	dh_installchangelogs
	dh_installchangelogs ChangeLog
	dh_installdocs
	dh_installdocs README
	dh_installexamples doc/skel-ui.example
	dh_install

	: # only use upstart in Ubuntu 9.10 and higher
	if [ "$(DISTRIB)" != "Ubuntu" ]; then \
		cp $(CURDIR)/debian/ufw.logrotate.debian $(CURDIR)/debian/ufw.logrotate ; \
		cp $(CURDIR)/debian/ufw.init.debian $(CURDIR)/debian/ufw.init ; \
		dh_installinit --no-start --no-restart-on-upgrade --update-rcd-params="start 39 S . stop 39 1 ." ; \
	else \
		cp $(CURDIR)/debian/ufw.logrotate.ubuntu $(CURDIR)/debian/ufw.logrotate ; \
		if [ "$(DISTRIB_VERSION_MAJOR)" = "9" ] && \
			[ "$(DISTRIB_VERSION_MINOR)" = "10" ] || \
			[ "$(DISTRIB_VERSION_MAJOR)" -gt "9" ]; then \
			cp $(CURDIR)/debian/ufw.upstart.ubuntu $(CURDIR)/debian/ufw.upstart ; \
			dh_installinit --no-start --no-restart-on-upgrade ; \
		else \
			cp $(CURDIR)/debian/ufw.init.debian $(CURDIR)/debian/ufw.init ; \
			dh_installinit --no-start --no-restart-on-upgrade --update-rcd-params="start 39 S . stop 39 1 ." ; \
		fi \
	fi
	dh_installlogrotate
	dh_installman
	dh_installdebconf
	dh_lintian

	: # Replace all '#!' calls to python with $(PYTHON)
	: # and make them executable
	for i in `find debian -mindepth 3 -type f`; do \
		sed '1s,#!.*python[^ ]*\(.*\),#! $(PYTHON)\1,' \
			$$i > $$i.temp; \
		if cmp --quiet $$i $$i.temp; then \
			rm -f $$i.temp; \
		else \
			mv -f $$i.temp $$i; \
			chmod 755 $$i; \
			echo "fixed interpreter: $$i"; \
		fi; \
	done
	# Don't install profiles on Ubuntu
	if [ "$(DISTRIB)" = "Ubuntu" ]; then \
		profiles="$(wildcard ./debian/ufw/etc/ufw/applications.d/ufw-*)";\
		for p in $$profiles; do \
	    	rm -f $$p; \
		done \
	fi
	dh_python2
	dh_compress
	dh_fixperms
	dh_installdeb
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary: binary-indep binary-arch
.PHONY: build clean binary install

## ufw 0.33

=== Makefile ===
--- 
+++ 
@@ -9,6 +9,10 @@
 TARDST   = $(TARBALLS)/$(SRCVER).tar.gz
 PYFLAKES = $(TMPDIR)/pyflakes.out
 PYFLAKES_EXE = pyflakes
+
+ifndef $(PYTHON)
+export PYTHON=python
+endif
 
 all:
 	# Use setup.py to install. See README for details
@@ -24,7 +28,7 @@
 	make -C locales all
 
 test:
-	./run_tests.sh -s
+	./run_tests.sh -s -i $(PYTHON)
 
 syntax-check: clean
 	$(shell mkdir $(TMPDIR) && $(PYFLAKES_EXE) src 2>&1 | grep -v "undefined name '_'" > $(PYFLAKES))
@@ -55,13 +59,13 @@
 
 evaluate: clean
 	mkdir -p $(TMPDIR)/ufw/usr $(TMPDIR)/ufw/etc
-	python ./setup.py install --home=$(TMPDIR)/ufw
-	PYTHONPATH=$(PYTHONPATH):$(TMPDIR)/ufw/lib/python $(TMPDIR)/ufw/usr/sbin/ufw version
+	$(PYTHON) ./setup.py install --home=$(TMPDIR)/ufw
+	PYTHONPATH=$(PYTHONPATH):$(TMPDIR)/ufw/lib/python $(PYTHON) $(TMPDIR)/ufw/usr/sbin/ufw version
 	sed -i 's/self.do_checks = True/self.do_checks = False/' $(TMPDIR)/ufw/lib/python/ufw/backend.py
 	cp ./examples/* $(TMPDIR)/ufw/etc/ufw/applications.d
 	# Test with:
-	# PYTHONPATH=$$PYTHONPATH:$(TMPDIR)/ufw/lib/python $(TMPDIR)/ufw/usr/sbin/ufw ...
-	# sudo sh -c "PYTHONPATH=$$PYTHONPATH:$(TMPDIR)/ufw/lib/python $(TMPDIR)/ufw/usr/sbin/ufw ..."
+	# PYTHONPATH=$$PYTHONPATH:$(TMPDIR)/ufw/lib/python $(PYTHON) $(TMPDIR)/ufw/usr/sbin/ufw ...
+	# sudo sh -c "PYTHONPATH=$$PYTHONPATH:$(TMPDIR)/ufw/lib/python $(PYTHON) $(TMPDIR)/ufw/usr/sbin/ufw ..."
 
 devel: evaluate
 	cp -f ./tests/defaults/profiles/* $(TMPDIR)/ufw/etc/ufw/applications.d

=== debian/changelog ===
ufw (0.33-0ubuntu2.1) quantal-proposed; urgency=low

  * debian/patches/0004-lp1039729.patch: Skip get_netfilter_capabilities()
    with ipv6 if ipv6 is disabled (LP: #1039729)

 -- Jamie Strandboge <jamie@ubuntu.com>  Tue, 04 Dec 2012 09:28:20 -0600

ufw (0.33-0ubuntu2) quantal; urgency=low

  * debian/patches/0002-lp1044361.patch: move netfilter capabilities checking
    into initcaps(), and call initcaps() only when we need it (LP: #1044361)
  * 0003-fix-typeerror-on-error.patch: fix TypeError on error when using zh_CN

 -- Jamie Strandboge <jamie@ubuntu.com>  Mon, 24 Sep 2012 08:52:57 -0500

ufw (0.33-0ubuntu1) quantal; urgency=low

  * New upstream release. Fixes the following bugs:
    - also use correct ports for DHCPv6. Thanks to Marco Davids (LP: #1007326)
    - add IPv6 limit support (LP: #951462)
    - add zh_TW translation (LP: #868195)
    - add 'show added' report (LP: #987784)
    - remove ACCEPT_NO_TRACK option since it never worked (LP: #787955)
  * debian/(after|before)6.rules.md5sum: adjust for recently missed shipped
    configurations

 -- Jamie Strandboge <jamie@ubuntu.com>  Fri, 17 Aug 2012 14:32:01 -0500

ufw (0.32-0ubuntu2) quantal; urgency=low

  * Simplify unload of firewall and play nicely with other firewall tools by
    using ufw-init instead of iptables directly. 'ufw-init stop' by design
    leaves a few empty chains around, but they won't get in the way of
    anything and are gone after the next reboot. Using upstream's ufw-init has
    the important benefit of always cleaning what it needs. (Closes: 672439).
    - debian/ufw.prerm: call '/lib/ufw/ufw-init stop' on removal
    - debian/ufw.postrm: don't flush the chains on purge

 -- Jamie Strandboge <jamie@ubuntu.com>  Fri, 20 Jul 2012 13:00:35 -0500

ufw (0.32-0ubuntu1) quantal; urgency=low

  * New upstream release featuring Python 3 port (LP: #1001657)
  * debian/control:
    - clean up Depends and Build-Depends
    - Build-Depends on python3
    - add python-ufw for installing python2 modules
    - add X-Python3-Version: >= 3.2
    - update Vcs-Bzr
  * add debian/python-ufw.install
  * debian/rules:
    - use --install-layout=deb
    - adjust PYTHON to use python3
    - adjust PYVERS to use py3versions
    - add PYTHON2
    - run tests for both PYTHON and PYTHON2
    - run setup.py with both PYTHON and PYTHON2
    - use dh_python3 for ufw
    - use dh_python2 for python-ufw
  * debian/ufw.lintian-overrides
    - remove old unneeded override
    - add postrm-does-not-call-updaterc.d-for-init.d-script since Ubuntu's
      debhelper adds code to postinst that does nothing on Ubuntu, but doesn't
      add the corresponding code to postrm

 -- Jamie Strandboge <jamie@ubuntu.com>  Fri, 06 Jul 2012 11:44:48 -0500

=== debian/rules ===
--- 
+++ 
@@ -4,8 +4,9 @@
 # Uncomment this to turn on verbose mode.
 #export DH_VERBOSE=1
 
-PYTHON  := /usr/bin/python
-PYVERS  := $(shell pyversions -vr)
+PYTHON  := /usr/bin/python3
+PYVERS  := $(shell py3versions -vr)
+PYTHON2 := /usr/bin/python2
 PKGVERS := $(shell dpkg-parsechangelog | grep ^Version: | cut -d ' ' -f 2)
 DISTRIB := $(shell lsb_release -i -s)
 
@@ -44,15 +45,17 @@
 	sed -i "s/^ufw_version = .*/ufw_version = '$(PKGVERS)'/" ./setup.py
 
 ifeq (,$(findstring nocheck,$(DEB_BUILD_OPTIONS)))
+	./run_tests.sh -i $(PYTHON2)
 	./run_tests.sh -i $(PYTHON)
 endif
 
-	$(PYTHON) ./setup.py install --root=$(CURDIR)/debian/ufw
+	$(PYTHON2) ./setup.py install --root=$(CURDIR)/debian/tmp --install-layout=deb
+	$(PYTHON) ./setup.py install --root=$(CURDIR)/debian/tmp --install-layout=deb
 
 	# these shouldn't be conffiles
-	mv $(CURDIR)/debian/ufw/etc/ufw/*.rules $(CURDIR)/debian/ufw/usr/share/ufw
-	mv $(CURDIR)/debian/ufw/etc/ufw/ufw.conf $(CURDIR)/debian/ufw/usr/share/ufw
-	mv $(CURDIR)/debian/ufw/lib/ufw/*.rules $(CURDIR)/debian/ufw/usr/share/ufw
+	mv $(CURDIR)/debian/tmp/etc/ufw/*.rules $(CURDIR)/debian/tmp/usr/share/ufw
+	mv $(CURDIR)/debian/tmp/etc/ufw/ufw.conf $(CURDIR)/debian/tmp/usr/share/ufw
+	mv $(CURDIR)/debian/tmp/lib/ufw/*.rules $(CURDIR)/debian/tmp/usr/share/ufw
 
 	# Rename and install the shell-completion file
 	cp $(CURDIR)/shell-completion/bash $(CURDIR)/debian/ufw/etc/bash_completion.d/ufw
@@ -106,12 +109,10 @@
 	done
 	# Don't install profiles on Ubuntu
 	if [ "$(DISTRIB)" = "Ubuntu" ]; then \
-		profiles="$(wildcard ./debian/ufw/etc/ufw/applications.d/ufw-*)";\
-		for p in $$profiles; do \
-	    	rm -f $$p; \
-		done \
+		rm -f $(CURDIR)/debian/ufw/etc/ufw/applications.d/ufw-* ; \
 	fi
-	dh_python2
+	dh_python2 -p python-ufw
+	dh_python3 -p ufw
 	dh_compress
 	dh_fixperms
 	dh_installdeb

=== debian/watch ===
version=3
http://launchpad.net/ufw/+download/ http://launchpad.net/ufw/.*/ufw-(.*)\.tar\.gz

## ufw 0.34~rc

=== Makefile ===
--- 
+++ 
@@ -30,6 +30,19 @@
 test:
 	./run_tests.sh -s -i $(PYTHON)
 
+unittest:
+	./run_tests.sh -s -i $(PYTHON) unit
+
+coverage:
+	# No python3 coverage yet
+	#$(PYTHON) ./tests/unit/runner.py
+	python -m coverage run ./tests/unit/runner.py
+
+coverage-report:
+	# No python3 coverage yet
+	#$(PYTHON) ./tests/unit/runner.py
+	python -m coverage report --show-missing --omit="tests/*"
+
 syntax-check: clean
 	$(shell mkdir $(TMPDIR) && $(PYFLAKES_EXE) src 2>&1 | grep -v "undefined name '_'" > $(PYFLAKES))
 	cat "$(PYFLAKES)"
@@ -47,21 +60,24 @@
 		echo "PASS"; \
 	done; \
 
-check: syntax-check man-check test
+check: syntax-check man-check test unittest
 
 # These are only used in development
 clean:
 	rm -rf ./build
 	rm -rf ./staging
-	rm -rf ./tests/testarea
+	rm -rf ./tests/testarea ./tests/unit/tmp
 	rm -rf $(TMPDIR)
 	rm -f ./locales/mo/*.mo
+	rm -f ./tests/unit/*.pyc ./tests/*.pyc ./src/*.pyc
+	rm -rf ./tests/unit/__pycache__ ./tests/__pycache__ ./src/__pycache__
+	rm -rf ./.coverage
+	rm -f ./ufw               # unittest symlink
 
 evaluate: clean
 	mkdir -p $(TMPDIR)/ufw/usr $(TMPDIR)/ufw/etc
-	$(PYTHON) ./setup.py install --home=$(TMPDIR)/ufw
+	UFW_SKIP_CHECKS=1 $(PYTHON) ./setup.py install --home=$(TMPDIR)/ufw
 	PYTHONPATH=$(PYTHONPATH):$(TMPDIR)/ufw/lib/python $(PYTHON) $(TMPDIR)/ufw/usr/sbin/ufw version
-	sed -i 's/self.do_checks = True/self.do_checks = False/' $(TMPDIR)/ufw/lib/python/ufw/backend.py
 	cp ./examples/* $(TMPDIR)/ufw/etc/ufw/applications.d
 	# Test with:
 	# PYTHONPATH=$$PYTHONPATH:$(TMPDIR)/ufw/lib/python $(PYTHON) $(TMPDIR)/ufw/usr/sbin/ufw ...

=== debian/changelog ===
ufw (0.34~rc-0ubuntu2) trusty; urgency=medium

  * debian/patches/0002-lp1078665.patch: distinguish between v4 and v6 rules
    when both addresses are 'any' (LP: #1078665). This can be dropped with
    0.34 release.
  * debian/ufw.postinst:
    - drop old reload of policy for upgrades to 0.30.1-2
    - add new ufw[6]-track-forward primary chains on upgrade
  * debian/patches/0003-manpage-hook-path.patch: update locations of hook
    scripts. This can be dropped with 0.34 release.
  * debian/patches/0004-add-safe-icmp-to-forward.patch: update before*.rules
    to add safe icmp to ufw-before-forward. This can be dropped with 0.34
    release.
  * debian/before[6].rules.md5sum: adjusted for new release

 -- Jamie Strandboge <jamie@ubuntu.com>  Fri, 28 Feb 2014 08:59:13 -0600

ufw (0.34~rc-0ubuntu1) trusty; urgency=medium

  * New upstream pre-release (LP: #1059060, #1065297, #1062521, #1101304,
    LP: #1075975, #1089262, #262421)
  * Dropped the following patches now included upstream:
    - 0002-lp1044361.patch
    - 0003-fix-typeerror-on-error.patch
    - 0004-lp1039729.patch
    - 0005-lp1191197.patch
  * Remaining changes:
    - 0001-optimize-boot.patch: only read in /etc/ufw/ufw.conf when disabled
  * debian/before[6].rules.md5sum: adjusted for new release
  * debian/control: update Standards-Version to 3.9.5
  * debian/rules:
    - only ship /usr/share/ufw/iptables/*rules and not /usr/share/ufw/
    - *.init files should also be config files
  * debian/ufw.links: added to makes symlinks from /usr/share/ufw/iptables/*
    to /usr/share/ufw/ (so ucf is happy on upgrades)
  * debian/ufw.postinst:
    - use TEMPLATE_PATH/iptables/*rules instead of TEMPLATE_PATH/*rules (not
      strictly required since we are using dh_link, but makes the intent
      clearer)
    - copy /usr/share/ufw/*.init in to /etc/ufw

 -- Jamie Strandboge <jamie@ubuntu.com>  Thu, 20 Feb 2014 09:23:54 -0600

ufw (0.33-2) unstable; urgency=low

  * debian/control: python-ufw should Breaks/Replaces on ufw << 0.32-0ubuntu1
    (Closes: 731863)

 -- Jamie Strandboge <jamie@ubuntu.com>  Tue, 10 Dec 2013 10:44:48 -0600

ufw (0.33-1) unstable; urgency=low

  * New upstream release (Closes: 711711, Closes: 691135, Closes: 704728).
    Sync back up with Ubuntu (all changes here except for Polish debconf
    translation and Standards-Version already in Ubuntu). Add the following
    patches from Ubuntu which can be dropped in 0.34:
    - debian/patches/0002-lp1044361.patch: move netfilter capabilities
      checking into initcaps(), and call initcaps() only when we need it
    - 0003-fix-typeerror-on-error.patch: fix TypeError on error when using
      zh_CN
    - debian/patches/0004-lp1039729.patch: Skip get_netfilter_capabilities()
      with ipv6 if ipv6 is disabled
    - debian/patches/0005-lp1191197.patch: add check for -m rt --rt-type 0
  * debian/po/pl.po: add Polish translation of debconf templates. Thanks to
    Michal Kulach (Closes: 667942)
  * debian/watch: use https instead of http
  * debian/(after|before)6.rules.md5sum: adjust for recently missed shipped
    configurations
  * debian/control:
    - clean up Depends and Build-Depends
    - Build-Depends on python3
    - add python-ufw for installing python2 modules
    - add X-Python3-Version: >= 3.2
    - update Standards-Version to 3.9.4
  * add debian/python-ufw.install
  * debian/rules:
    - use --install-layout=deb
    - adjust PYTHON to use python3
    - adjust PYVERS to use py3versions
    - add PYTHON2
    - run tests for both PYTHON and PYTHON2
    - run setup.py with both PYTHON and PYTHON2
    - use dh_python3 for ufw
    - use dh_python2 for python-ufw
  * debian/ufw.lintian-overrides
    - remove old unneeded override
    - add postrm-does-not-call-updaterc.d-for-init.d-script since Ubuntu's
      debhelper adds code to postinst that does nothing on Ubuntu, but doesn't
      add the corresponding code to postrm

 -- Jamie Strandboge <jamie@ubuntu.com>  Tue, 26 Nov 2013 12:51:51 -0600

=== debian/control ===
Source: ufw
Section: admin
XS-Python-Version: >= 2.5
X-Python3-Version: >= 3.2
Priority: optional
Maintainer: Jamie Strandboge <jamie@ubuntu.com>
Build-Depends-Indep:
 iptables,
 lsb-release,
 netbase,
 sed (>= 3.95)
Build-Depends:
 debhelper (>= 7.3.15ubuntu2),
 po-debconf,
 python (>= 2.6.6-3~),
 python3 (>= 3.2)
Standards-Version: 3.9.5
Homepage: https://launchpad.net/ufw
Vcs-Bzr: https://bazaar.launchpad.net/~jdstrand/ufw/ufw-debian

Package: ufw
Architecture: all
Suggests: rsyslog
Depends:
 debconf,
 iptables,
 ucf,
 ${python3:Depends},
 ${misc:Depends}
XB-Python-Version: ${python3:Versions}
Description: program for managing a Netfilter firewall
 The Uncomplicated FireWall is a front-end for iptables, to make managing a
 Netfilter firewall easier. It provides a command line interface with syntax
 similar to OpenBSD's Packet Filter. It is particularly well-suited as a
 host-based firewall.

Package: python-ufw
Section: python
Architecture: all
Depends:
 ${python:Depends},
 ${misc:Depends}
XB-Python-Version: ${python:Versions}
Breaks: ufw (<< 0.32-0ubuntu1)
Replaces: ufw (<< 0.32-0ubuntu1)
Description: Uncomplicated FireWall Python modules
 The Uncomplicated FireWall is a front-end for iptables, to make managing a
 Netfilter firewall easier. This package includes the Python modules for the
 Uncomplicated FireWall.

=== debian/rules ===
--- 
+++ 
@@ -53,9 +53,14 @@
 	$(PYTHON) ./setup.py install --root=$(CURDIR)/debian/tmp --install-layout=deb
 
 	# these shouldn't be conffiles
-	mv $(CURDIR)/debian/tmp/etc/ufw/*.rules $(CURDIR)/debian/tmp/usr/share/ufw
 	mv $(CURDIR)/debian/tmp/etc/ufw/ufw.conf $(CURDIR)/debian/tmp/usr/share/ufw
-	mv $(CURDIR)/debian/tmp/lib/ufw/*.rules $(CURDIR)/debian/tmp/usr/share/ufw
+	mv $(CURDIR)/debian/tmp/etc/ufw/*.init $(CURDIR)/debian/tmp/usr/share/ufw
+	# these shouldn't be conffiles either, but we'll use the rules from
+	# /usr/share/ufw/iptables so just delete these and we'll use dh_link
+	# later
+	rm -f $(CURDIR)/debian/tmp/etc/ufw/*.rules
+	rm -f $(CURDIR)/debian/tmp/lib/ufw/*.rules
+	dh_link
 
 	# Rename and install the shell-completion file
 	cp $(CURDIR)/shell-completion/bash $(CURDIR)/debian/ufw/etc/bash_completion.d/ufw
